# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class VpcEndpointServiceAllowedPrinciple(pulumi.CustomResource):
    """
    Provides a resource to allow a principal to discover a VPC endpoint service.
    
    ~> **NOTE on VPC Endpoint Services and VPC Endpoint Service Allowed Principals:** Terraform provides
    both a standalone [VPC Endpoint Service Allowed Principal](vpc_endpoint_service_allowed_principal.html) resource
    and a VPC Endpoint Service resource with an `allowed_principals` attribute. Do not use the same principal ARN in both
    a VPC Endpoint Service resource and a VPC Endpoint Service Allowed Principal resource. Doing so will cause a conflict
    and will overwrite the association.
    """
    def __init__(__self__, __name__, __opts__=None, principal_arn=None, vpc_endpoint_service_id=None):
        """Create a VpcEndpointServiceAllowedPrinciple resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not principal_arn:
            raise TypeError('Missing required property principal_arn')
        elif not isinstance(principal_arn, basestring):
            raise TypeError('Expected property principal_arn to be a basestring')
        __self__.principal_arn = principal_arn
        """
        The ARN of the principal to allow permissions.
        """
        __props__['principalArn'] = principal_arn

        if not vpc_endpoint_service_id:
            raise TypeError('Missing required property vpc_endpoint_service_id')
        elif not isinstance(vpc_endpoint_service_id, basestring):
            raise TypeError('Expected property vpc_endpoint_service_id to be a basestring')
        __self__.vpc_endpoint_service_id = vpc_endpoint_service_id
        """
        The ID of the VPC endpoint service to allow permission.
        """
        __props__['vpcEndpointServiceId'] = vpc_endpoint_service_id

        super(VpcEndpointServiceAllowedPrinciple, __self__).__init__(
            'aws:ec2/vpcEndpointServiceAllowedPrinciple:VpcEndpointServiceAllowedPrinciple',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'principalArn' in outs:
            self.principal_arn = outs['principalArn']
        if 'vpcEndpointServiceId' in outs:
            self.vpc_endpoint_service_id = outs['vpcEndpointServiceId']
