# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import pulumi
import pulumi.runtime

class PolicyAttachment(pulumi.CustomResource):
    """
    Provides a resource to attach an AWS Organizations policy to an organization account, root, or unit.
    """
    def __init__(__self__, __name__, __opts__=None, policy_id=None, target_id=None):
        """Create a PolicyAttachment resource with the given unique name, props, and options."""
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, basestring):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        if not policy_id:
            raise TypeError('Missing required property policy_id')
        elif not isinstance(policy_id, basestring):
            raise TypeError('Expected property policy_id to be a basestring')
        __self__.policy_id = policy_id
        """
        The unique identifier (ID) of the policy that you want to attach to the target.
        """
        __props__['policyId'] = policy_id

        if not target_id:
            raise TypeError('Missing required property target_id')
        elif not isinstance(target_id, basestring):
            raise TypeError('Expected property target_id to be a basestring')
        __self__.target_id = target_id
        """
        The unique identifier (ID) of the root, organizational unit, or account number that you want to attach the policy to.
        """
        __props__['targetId'] = target_id

        super(PolicyAttachment, __self__).__init__(
            'aws:organizations/policyAttachment:PolicyAttachment',
            __name__,
            __props__,
            __opts__)

    def set_outputs(self, outs):
        if 'policyId' in outs:
            self.policy_id = outs['policyId']
        if 'targetId' in outs:
            self.target_id = outs['targetId']
